Debian Bug report logs - #696429
ITP: jhc -- a haskell compiler.

version graph

Package: wnpp; Maintainer for wnpp is wnpp@debian.org;

Reported by: Kiwamu Okabe <kiwamu@debian.or.jp>

Date: Thu, 20 Dec 2012 17:27:02 UTC

Owned by: Kiwamu Okabe <kiwamu@debian.or.jp>

Severity: wishlist

Fixed in version jhc/0.8.0~darcs20120314-1

Done: Kiwamu Okabe <kiwamu@debian.or.jp>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org, wnpp@debian.org:
Bug#696429; Package wnpp. (Thu, 20 Dec 2012 17:27:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kiwamu Okabe <kiwamu@debian.or.jp>:
New Bug report received and forwarded. Copy sent to debian-devel@lists.debian.org, wnpp@debian.org. (Thu, 20 Dec 2012 17:27:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Kiwamu Okabe <kiwamu@debian.or.jp>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: ITP: jhc -- a haskell compiler.
Date: Fri, 21 Dec 2012 02:22:29 +0900
Package: wnpp
Severity: wishlist
Owner: Kiwamu Okabe <kiwamu@debian.or.jp>

* Package name    : jhc
  Version         : 0.8.0~darcs20120314
  Upstream Author : John Meacham <john@repetae.net>
* URL             : http://repetae.net/computer/jhc/
  Vcs-Browser     : http://anonscm.debian.org/gitweb/?p=collab-maint/jhc.git
* License         : GPL2+
  Programming Lang: Haskell
  Description     : A haskell compiler
 Jhc is a haskell compiler which aims to produce the most efficient
 programs possible via whole program analysis and other optimizations.

-- 
Kiwamu Okabe



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Kiwamu Okabe <kiwamu@debian.or.jp>:
Bug#696429; Package wnpp. (Thu, 20 Dec 2012 18:00:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Samuel Thibault <sthibault@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Kiwamu Okabe <kiwamu@debian.or.jp>. (Thu, 20 Dec 2012 18:00:03 GMT) Full text and rfc822 format available.

Message #10 received at 696429@bugs.debian.org (full text, mbox):

From: Samuel Thibault <sthibault@debian.org>
To: Kiwamu Okabe <kiwamu@debian.or.jp>, 696429@bugs.debian.org
Cc: debian-devel@lists.debian.org
Subject: Re: Bug#696429: ITP: jhc -- a haskell compiler.
Date: Thu, 20 Dec 2012 18:56:29 +0100
Hello,

Kiwamu Okabe, le Fri 21 Dec 2012 02:22:29 +0900, a écrit :
> * Package name    : jhc
>   Version         : 0.8.0~darcs20120314
>   Upstream Author : John Meacham <john@repetae.net>
> * URL             : http://repetae.net/computer/jhc/
>   Vcs-Browser     : http://anonscm.debian.org/gitweb/?p=collab-maint/jhc.git
> * License         : GPL2+
>   Programming Lang: Haskell
>   Description     : A haskell compiler
>  Jhc is a haskell compiler which aims to produce the most efficient
>  programs possible via whole program analysis and other optimizations.

Could it be used to bootstrap ghc compilation way more easily?

Samuel



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Kiwamu Okabe <kiwamu@debian.or.jp>:
Bug#696429; Package wnpp. (Thu, 20 Dec 2012 19:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joey Hess <joeyh@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Kiwamu Okabe <kiwamu@debian.or.jp>. (Thu, 20 Dec 2012 19:21:05 GMT) Full text and rfc822 format available.

Message #15 received at 696429@bugs.debian.org (full text, mbox):

From: Joey Hess <joeyh@debian.org>
To: Kiwamu Okabe <kiwamu@debian.or.jp>, 696429@bugs.debian.org, debian-devel@lists.debian.org
Subject: Re: Bug#696429: ITP: jhc -- a haskell compiler.
Date: Thu, 20 Dec 2012 15:17:48 -0400
[Message part 1 (text/plain, inline)]
Samuel Thibault wrote:
> Could it be used to bootstrap ghc compilation way more easily?

Given the number of extensions used in ghc's own code, many of which
jhc does not support, this seems unlikely, at least not without
first mechanically converting its code to an intermediate form like
Haskell 98.

Also, jhc would still need to be ported to new arches. ;)

Also, you'd probably need quite a lot of memory (probably gigabytes) to
compile something as large as ghc with jhc, since jhc is lacking even
garbage collection.

It'd be nice to have jhc in Debian though. Although the Haskell "compiler"
we really need, IMHO, is Fay.

-- 
see shy jo
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Kiwamu Okabe <kiwamu@debian.or.jp>:
Bug#696429; Package wnpp. (Thu, 20 Dec 2012 22:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Kiwamu Okabe <kiwamu@debian.or.jp>. (Thu, 20 Dec 2012 22:03:03 GMT) Full text and rfc822 format available.

Message #20 received at 696429@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: debian-devel@lists.debian.org
Cc: 696429@bugs.debian.org
Subject: Re: Bug#696429: ITP: jhc -- a haskell compiler.
Date: Thu, 20 Dec 2012 23:01:23 +0100
[Message part 1 (text/plain, inline)]
Hi Kiwamu,

Am Freitag, den 21.12.2012, 02:22 +0900 schrieb Kiwamu Okabe:
> Package: wnpp
> Severity: wishlist
> Owner: Kiwamu Okabe <kiwamu@debian.or.jp>
> 
> * Package name    : jhc
>   Version         : 0.8.0~darcs20120314
>   Upstream Author : John Meacham <john@repetae.net>
> * URL             : http://repetae.net/computer/jhc/
>   Vcs-Browser     : http://anonscm.debian.org/gitweb/?p=collab-maint/jhc.git
> * License         : GPL2+
>   Programming Lang: Haskell
>   Description     : A haskell compiler
>  Jhc is a haskell compiler which aims to produce the most efficient
>  programs possible via whole program analysis and other optimizations.

just wondering: Is jhc in a state where it is a useful tool (and not
“just” an interesting and worthwhile research undertaking)? How actively
is it maintained (last commit is 9 month ago)?

Haskell-World is full of experiments that are great, but not really much
used when packaged into a Debian package.

Am Donnerstag, den 20.12.2012, 15:17 -0400 schrieb Joey Hess:
> It'd be nice to have jhc in Debian though. Although the Haskell
> "compiler" we really need, IMHO, is Fay.

I agree that Fay is a great tool, but I’m not sure it is ready yet, not
even supporting "let (x,y) = ...", let alone type classes. Too bad that
they are not based on GHC core, that would make a lot of things easier.
Also, the problem of how to distribute libraries for Fay is not solved
yet. But of course: Please do remind me from time to time to reconsider,
as Fay (or one of its competitors) evolves.

Greetings,
Joachim
-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#696429; Package wnpp. (Thu, 20 Dec 2012 23:24:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kiwamu Okabe <kiwamu@debian.or.jp>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Thu, 20 Dec 2012 23:24:03 GMT) Full text and rfc822 format available.

Message #25 received at 696429@bugs.debian.org (full text, mbox):

From: Kiwamu Okabe <kiwamu@debian.or.jp>
To: debian-devel@lists.debian.org
Cc: 696429@bugs.debian.org
Subject: Re: Bug#696429: ITP: jhc -- a haskell compiler.
Date: Fri, 21 Dec 2012 08:21:31 +0900
Hi Joachim,

On Fri, Dec 21, 2012 at 7:01 AM, Joachim Breitner <nomeata@debian.org> wrote:
> just wondering: Is jhc in a state where it is a useful tool (and not
> “just” an interesting and worthwhile research undertaking)? How actively
> is it maintained (last commit is 9 month ago)?

Jhs is useful for me, now.
I am trying to rewrite NetBSD bootloader with Haskell.

https://gitorious.org/metasepi/netbsd-arafura/commit/5e6188b80bd9e51185ed04c2a3455f1039723552

GHC cannot it, because GHC produces BIG execute binary and has many
depending on libraries. Please see below.

$ cat Fib.hs
fibonacci :: [Int]
fibonacci = 1:1:zipWith (+) fibonacci (tail fibonacci)
main :: IO ()
main = print $ take 40 fibonacci
$ ghc -o Fib_ghc Fib.hs
$ jhc -o Fib_jhc Fib.hs
$ size Fib_ghc Fib_jhc
   text    data     bss     dec     hex filename
 705068   38536   46776  790380   c0f6c Fib_ghc
  15808    1300     744   17852    45bc Fib_jhc
$ ldd Fib_ghc Fib_jhc
Fib_ghc:
        linux-vdso.so.1 (0x00007fff87bff000)
        libgmp.so.10 => /usr/lib/x86_64-linux-gnu/libgmp.so.10
(0x00007f089412e000)
        libffi.so.5 => /usr/lib/x86_64-linux-gnu/libffi.so.5
(0x00007f0893f21000)
        libm.so.6 => /lib/x86_64-linux-gnu/libm.so.6 (0x00007f0893c26000)
        librt.so.1 => /lib/x86_64-linux-gnu/librt.so.1 (0x00007f0893a1e000)
        libdl.so.2 => /lib/x86_64-linux-gnu/libdl.so.2 (0x00007f089381a000)
        libc.so.6 => /lib/x86_64-linux-gnu/libc.so.6 (0x00007f0893471000)
        libpthread.so.0 => /lib/x86_64-linux-gnu/libpthread.so.0
(0x00007f0893255000)
        /lib64/ld-linux-x86-64.so.2 (0x00007f08943d5000)
Fib_jhc:
        linux-vdso.so.1 (0x00007fff179d5000)
        libc.so.6 => /lib/x86_64-linux-gnu/libc.so.6 (0x00007fc2a4193000)
        /lib64/ld-linux-x86-64.so.2 (0x00007fc2a4573000)

And jhc's -C option produces portable C language file. It's useful
with custom RTS.

Regards,
--
Kiwamu Okabe



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Kiwamu Okabe <kiwamu@debian.or.jp>:
Bug#696429; Package wnpp. (Fri, 21 Dec 2012 11:12:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Joachim Breitner <nomeata@debian.org>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Kiwamu Okabe <kiwamu@debian.or.jp>. (Fri, 21 Dec 2012 11:12:05 GMT) Full text and rfc822 format available.

Message #30 received at 696429@bugs.debian.org (full text, mbox):

From: Joachim Breitner <nomeata@debian.org>
To: 696429@bugs.debian.org
Cc: debian-devel@lists.debian.org
Subject: Re: Bug#696429: ITP: jhc -- a haskell compiler.
Date: Fri, 21 Dec 2012 12:10:09 +0100
[Message part 1 (text/plain, inline)]
Hi,

Am Freitag, den 21.12.2012, 08:21 +0900 schrieb Kiwamu Okabe:
> Jhs is useful for me, now.
> I am trying to rewrite NetBSD bootloader with Haskell.
> 
> [..]

Great, just checking :-)

Greetings,
Joachim

-- 
Joachim "nomeata" Breitner
Debian Developer
  nomeata@debian.org | ICQ# 74513189 | GPG-Keyid: 4743206C
  JID: nomeata@joachim-breitner.de | http://people.debian.org/~nomeata
[signature.asc (application/pgp-signature, inline)]

Added tag(s) pending. Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Tue, 19 Feb 2013 07:18:04 GMT) Full text and rfc822 format available.

Reply sent to Kiwamu Okabe <kiwamu@debian.or.jp>:
You have taken responsibility. (Tue, 09 Apr 2013 21:03:21 GMT) Full text and rfc822 format available.

Notification sent to Kiwamu Okabe <kiwamu@debian.or.jp>:
Bug acknowledged by developer. (Tue, 09 Apr 2013 21:03:21 GMT) Full text and rfc822 format available.

Message #37 received at 696429-close@bugs.debian.org (full text, mbox):

From: Kiwamu Okabe <kiwamu@debian.or.jp>
To: 696429-close@bugs.debian.org
Subject: Bug#696429: fixed in jhc 0.8.0~darcs20120314-1
Date: Tue, 09 Apr 2013 21:00:10 +0000
Source: jhc
Source-Version: 0.8.0~darcs20120314-1

We believe that the bug you reported is fixed in the latest version of
jhc, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 696429@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Kiwamu Okabe <kiwamu@debian.or.jp> (supplier of updated jhc package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Thu, 20 Dec 2012 20:43:09 +0900
Source: jhc
Binary: jhc jhc-doc
Architecture: source amd64 all
Version: 0.8.0~darcs20120314-1
Distribution: experimental
Urgency: low
Maintainer: Kiwamu Okabe <kiwamu@debian.or.jp>
Changed-By: Kiwamu Okabe <kiwamu@debian.or.jp>
Description: 
 jhc        - Haskell compiler that produce binary through C language
 jhc-doc    - Documentation for jhc
Closes: 696429
Changes: 
 jhc (0.8.0~darcs20120314-1) experimental; urgency=low
 .
   * Initial release (Closes: #696429)
Checksums-Sha1: 
 9a9d9afdc78917bde77f4c6bbecaf3125dc2a101 2190 jhc_0.8.0~darcs20120314-1.dsc
 aeb71d05e33ea1e4857858660c8956d7c55d884b 6658856 jhc_0.8.0~darcs20120314.orig.tar.gz
 cd6597e6729350b1bd9661f2a061c7dfeb7bf0c2 5851 jhc_0.8.0~darcs20120314-1.debian.tar.gz
 2cc158f15fd56ace2955163b7c86ea46f97927f6 4996852 jhc_0.8.0~darcs20120314-1_amd64.deb
 da4c38331019552451748af12df2e7641195b682 71408 jhc-doc_0.8.0~darcs20120314-1_all.deb
Checksums-Sha256: 
 f16eb606153f6f3621f281afa55845a470562bcc76e3b7ca1b5a5679baeb8437 2190 jhc_0.8.0~darcs20120314-1.dsc
 dfff48990e8d7f268e3e286dbcc6c48dfabec40982e53864b5015ee9c9c72085 6658856 jhc_0.8.0~darcs20120314.orig.tar.gz
 12f7510ba435eb706fc3dd10753afb25fc065e0e3c51e744b7ad8037049c43aa 5851 jhc_0.8.0~darcs20120314-1.debian.tar.gz
 d23d79900aa08da97e29a0ab8e40252f1ec2c77f385d4485ed2a280f9809374e 4996852 jhc_0.8.0~darcs20120314-1_amd64.deb
 e9a63b0313b0a970c08eb70b11ed9e752f459f982d00ea9144bf7106b9aaf476 71408 jhc-doc_0.8.0~darcs20120314-1_all.deb
Files: 
 3669eeb9028625a7c98ded9aa5dab71c 2190 haskell extra jhc_0.8.0~darcs20120314-1.dsc
 be77fc63721ef435944e92f43649671d 6658856 haskell extra jhc_0.8.0~darcs20120314.orig.tar.gz
 bc6787ac2ed785d1843fb4d25da26ad1 5851 haskell extra jhc_0.8.0~darcs20120314-1.debian.tar.gz
 8ba55591513e71c11f614cfb063d6d4b 4996852 haskell extra jhc_0.8.0~darcs20120314-1_amd64.deb
 61a3b364abd3974ed9742bc2aa88a71c 71408 doc extra jhc-doc_0.8.0~darcs20120314-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJRIxQgAAoJEHg5YZ3UOWaOllAQAIPKXxmytFaDwcyQWDAwFsgX
j3/iFrFGi95pnrhHWAJHmojlgeA6/MGBhcsD5CobJ8DGhzIfMf07DHhZnfsKKX04
vOBcBmkeOZGTSY3sjvPN9lrQxM8fqnghyrKfJN5WqBziDZSJ8UDCo6jI1Lbls1RG
QBIKYwWx2IkEkTJuvLYZhvM+8qPOUSm3oO+KSR7MUxx/TBy13w4JrOtidCcIfdFj
X76MoMABpGW8uyA63jaRbmqIk7v5Q1Z+0C9Ma8ogzQ+7cjfqNdIEJ9vP2GOZ4y+Y
uOVXE28aCbRXD94D40guVtW0WwiKULK62DMnbpekb9lwPU9yDWQr9fcYWDjp8g5P
+3t54geLYbEiN0KPlRCmyzgttwssZC4EsoPn0lvuzVvMuiH0BdHany/8WwFvKP2t
To/mqpc5JomLk9HnhynKiEzH1Jk2f1Qx9nxbH+w40IhALLx6Hh0e9FKdo9qawiLt
+Gxt0Ez7Rr2NP6Fr02VntqvLkg08SOv0WFqr5rAfpxyJZghTFUO/v6yFUzCvF8Vt
ihjxZmsmRmk2w7vj8Odbi2cK9MJYdg/1K62ZobwPHaZe9osqD9IETU0B6tt/wYw8
UelfOAB+3Abl21hu0eQP4VKW/BVq8zQoyFnEDomsqMhoFvNcJN+fVkV10xL0U1++
LLc41+fuXX2DI7XAwA+1
=xIxu
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 08 May 2013 07:28:24 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 07:30:03 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.